#region Namespaces
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.Intrinsics.X86;
using Autodesk.Revit.ApplicationServices;
using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
using Autodesk.Revit.UI.Selection;

#endregion

namespace RevitAddinDoors
{
    [Transaction(TransactionMode.Manual)]
    public class Command : IExternalCommand
    {
        public Result Execute(
          ExternalCommandData commandData,
          ref string message,
          ElementSet elements)
        {
            UIApplication uiapp = commandData.Application;
            UIDocument uidoc = uiapp.ActiveUIDocument;
            Application app = uiapp.Application;
            Document doc = uidoc.Document;

            //ファミリ＆タイプ別の扉の数を入れるディクショナリ
            Dictionary<string, int> doorsDict = new Dictionary<string, int>();

            //フィルタードエレメントコレクターでモデルの中の全ての壁を抽出
            IList<Element> doors = new FilteredElementCollector(doc).OfClass(typeof(FamilyInstance))
                .OfCategory(BuiltInCategory.OST_Doors).ToElements();

            string info = "ドアの数: " + doors.Count.ToString()+"\n";
            foreach (Element item in doors)
            {
                //ファミリ名、タイプ名を取得
                FamilyInstance door = item as FamilyInstance;
                string doorTypeName = door.Symbol.Name;
                string doorFamilyName = door.Symbol.Family.Name;

                // ディクショナリのキーのために文字列を作成。"@"はファミリ名とタイプ名を分離するため区切子
                string doorFamilyAndType = doorFamilyName + "@" + doorTypeName;

                // ディクショナリの中にキーdoorFamilyAndTypeが存在するか確認
                if (doorsDict.TryGetValue(doorFamilyAndType, out int count))
                {
                    // 存在する場合は1を加算する
                    doorsDict[doorFamilyAndType] = count + 1;
                }
                else
                {
                    doorsDict.Add(doorFamilyAndType, 1);
                }
            }
            // Dictionaryの中身を表示する            
            foreach (KeyValuePair<string, int> keyValue in doorsDict)
            {
                //キー
                string key = keyValue.Key;
                //バリュー
                int v = keyValue.Value;

                //keyをファミリ名とタイプ名に分ける
                string[] k = key.Split("@");

                //infoに情報を追加
                info += $"{k[0]} \t {k[1]} \t {v.ToString()}\n";
            }
            // 結果を表示
            TaskDialog.Show("扉の一覧", $"{info}");
            return Result.Succeeded;
        }
    }
}
